//$Id: main.cc,v 1.2 2002/11/11 15:14:43 murrayc Exp $ -*- c++ -*-

/* gtkmm example Copyright (C) 2002 gtkmm development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

using namespace std;

#include <iostream>
#include <fstream>
#include <vector>
#include <unistd.h>
#include <sigc++/class_slot.h>
#include <glibmm/random.h>
#include <glibmm/thread.h>
#include <glibmm/timer.h>
#include <gtkmm/main.h>
#include "moc.h"
#include "gmm.h"
#include "mathtools.h"
#include "managerwindow.h"
#include "manager.h"

extern char **environ;

manager::manager()
    : m(NULL), progr(0.0), finished(0)
{
}

manager::~manager()
{
    delete m;
}

void
manager::query(string filename, int length)
{
    m = new moc(3, 2048, 22050, 8);
    gmm *g = m->get_gmm_md5(m->get_md5(filename));
    vector<pair<gmm*, double> > *pl = m->get_nclosest(g, length, 2000);

    if (pl)
    {
        ofstream outf("/tmp/moc-manager.m3u");

        for (int i = 0; (i < (int)pl->size()); i++)
            outf << ((*pl)[i].first)->get_filename() << endl;
        outf.close();
        if (pl->size() > 0)
            finished = 1;
    }
}

void
manager::cancel()
{
    m->get_nclosest_cancel();
}

double
manager::get_progress()
{
    if (m != NULL)
        return m->get_progress();
    else
        return 0.0;
}

int
manager::is_finished()
{
    return finished;
}

int
main(int argc, char *argv[])
{
    Glib::thread_init();

    manager man;

    Glib::Thread *const query = Glib::Thread::create(
        SigC::bind(SigC::slot_class(man, &manager::query), string(argv[1]), 30),
            true);

    Gtk::Main kit(argc, argv);
    rnd_init();

    ManagerWindow window(&man);
    Gtk::Main::run(window);

    query->join();

    if (man.is_finished())
    {
        char *av[] = { "/usr/bin/xmms", "/tmp/moc-manager.m3u", NULL };
        execve("/usr/bin/xmms", av, environ);
    }

    return 0;
}
