//$Id: examplewindow.cc,v 1.2 2002/10/28 13:22:23 murrayc Exp $ -*- c++ -*-

/* gtkmm example Copyright (C) 2002 gtkmm development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <iostream>
#include "managerwindow.h"
#include "manager.h"

ManagerWindow::ManagerWindow(manager *mgr)
: m_VBox(false, 5),
  m_Alignment(0.5, 0.5, 0, 0),
  m_Button_Close("Cancel"),
  man(mgr)
{
  set_resizable();
  set_title("Playlist");
  set_position(Gtk::WIN_POS_CENTER);

  m_VBox.set_border_width(10);
  add(m_VBox);

  m_VBox.pack_start(m_Alignment, Gtk::PACK_SHRINK, 5);
  m_ProgressBar.set_text("Generating Playlist");
  m_Alignment.add(m_ProgressBar);

  // Add a timer callback to update the value of the progress bar:
  m_connection_id_timeout = Glib::signal_timeout().connect(
          SigC::slot(*this, &ManagerWindow::on_timeout), 1000);

  m_VBox.pack_start(m_Separator, Gtk::PACK_SHRINK);

  // Add a button to exit the program.
  m_VBox.pack_start(m_Button_Close, Gtk::PACK_SHRINK);
  m_Button_Close.signal_clicked().connect(
          SigC::slot(*this, &ManagerWindow::on_button_close));
  m_Button_Close.set_flags(Gtk::CAN_DEFAULT);
  m_Button_Close.grab_default();

  show_all_children();
}

ManagerWindow::~ManagerWindow()
{
}

void
ManagerWindow::on_button_close()
{
    man->cancel();
    hide();
}

void
ManagerWindow::on_button_launch()
{
    hide();
}

bool
ManagerWindow::on_timeout()
{
    double new_val = man->get_progress();
    m_ProgressBar.set_fraction(new_val);

    if (new_val == 1.0)
    {
        m_Button_Close.signal_clicked().connect(
                SigC::slot(*this, &ManagerWindow::on_button_launch));
        m_Button_Close.set_label("Launch Playist");
        hide();
        return false;
    }

    return true;
}

