/*
 *  $Id$
 *  Copyright (c) 2003, Dominik 'Aeneas' Schnitzer <dominik@schnitzer.at>
 *
 *  MoC - Master of Celebration is an automatic playlist generation tool using
 *  state-of-the-art music similarity measures
 *  http://www.schnitzer.at/dominik/moc/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __MATHTOOLS_H
#define __MATHTOOLS_H

using namespace std;

#include <valarray>
#include "vec.h"

#define NRNDCACHE_MAX 10000

void rnd_init();

double rnd(double min, double max);

double nrnd(const double& mean, const double& sdev);

double nrnd2(const double& mean, const double& sdev);

double nrnd3(const double& mean, const double& sdev, int next);

double euclidean(vec &v1, vec &v2);

#endif /* __MATHTOOLS_H */
