/*
 *  $Id$
 *  Copyright (c) 2003, Dominik 'Aeneas' Schnitzer <dominik@schnitzer.at>
 *
 *  MoC - Master of Celebration is an automatic playlist generation tool using
 *  state-of-the-art music similarity measures
 *  http://www.schnitzer.at/dominik/moc/
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __MFCC_H
#define __MFCC_H

#include <valarray>
#include "vec.h"
#include "mat.h"

using namespace std;

class mfcc
{
    private:
        unsigned int winsize;
        unsigned int sampr;
        unsigned int cepcoeffs;

        double max;

        double lowestfreq;
        unsigned int linf;
        unsigned int logf;
        unsigned int totf;
        double linsp;
        double logsp;
        valarray<double> lower;
        vec upper;
        vec center;
        vec triangleh;
        vec freqs;

        vec fftf;
        mat mfccfw;
        mat mfccdct;

        vec earmag;
        vec calcfb;
        vec calcdct;

    public:
        mfcc(unsigned int winsize, unsigned int sampr, unsigned int cepcoeffs);
        ~mfcc();

        void process(vec *in, vec *out);
};

#endif /* __MFCC_H */
