/*
 *  $Id$
 *  Copyright (c) 2003, Dominik 'Aeneas' Schnitzer <dominik@schnitzer.at>
 *
 *  MoC - Master of Celebration is an automatic playlist generation tool using
 *  state-of-the-art music similarity measures
 *  http://www.schnitzer.at/dominik/moc/
 *  
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  3B
 *  3B
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __STFT_H
#define __STFT_H

#include <valarray>
#include "fftw3.h"
#include "vec.h"

using namespace std;

class stft
{
    private:
        unsigned int winsize;
        unsigned int fftsize;
        double *hamming;
        double *data;
        fftw_plan plan;

    public:
        stft(unsigned int winsize);
        ~stft();

        // takes the aligned pcm data and applies a STFT on the given window
        void process(double *in, vec *out);

}; // stft

#endif // __STFT_H
